/*
 * $Id: abform.ui.h,v 1.14 2006/11/13 20:05:53 pjedryczek Exp $
 */


/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include <string.h>
#include <qmessagebox.h>
#include <qregexp.h>
#include <stdio.h>
#include <qlineedit.h>
#include <unistd.h>
#include <qsocketdevice.h>
#include "smsform.h"
#include "addabentryform.h"
#include "editabentryform.h"
#include "mainform.h"

#include "global.h"

void abForm::fetchAbSlot()
{
    unsigned int i,j;
    FILE *fpbackup;
    char backupfn[1024];
    bool telmem;
    bool isname;
    char buf[1024];
    char code[CODE_LEN];
    char howmany_str[8];
    unsigned int howmany;
    qgnokii_global *global = new qgnokii_global;
    char sysok[3];
    
    telmem = FALSE;
    // Check if readFromTelMemCheckBox is set
    if(readFromTelMemCheckBox->isChecked())
	telmem = TRUE;
    
     // Where the data file is?
    sprintf(backupfn, "%s/.qgnokii/addressbook", getenv("HOME"));
    
    if((fpbackup = fopen(backupfn, "w")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Internal error. Can't open names data file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Can't connect to QGnokiid", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    // Sending request to the qgnokii daemon
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(GETPB_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    
    // Getting data from daemon
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, GETPB_CODE) == 0)
	{
	    global->socket->readBlock(sysok, CODE_LEN);
	    if(strcmp(sysok, "WR") == 0)
	    {
		QMessageBox::critical(this, "Error", "This function on this OS is currently broken!", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
		return;
	    }
	    
	    if(telmem == TRUE)
		global->socket->writeBlock("ME", 3);
	    else
		global->socket->writeBlock("SM", 3);
	    global->socket->readBlock(howmany_str, sizeof(howmany_str));
	    howmany = atoi(howmany_str);
	    abTable->setNumRows(howmany);
	    strcpy(buf, "foo");
	    isname = TRUE;
	    i = 0;
	    j = 0;
	    while(i <= (howmany) && j <= (howmany)-1)
	    {
		global->socket->readBlock(buf, sizeof(buf));
		if(strcmp(buf, END_CODE) == 0)
		    break;
		if(strcmp(buf, "Empty name") == 0)
		{
		    abTable->setText(i, 0, buf);
		    abTable->setText(j, 1, buf);
		    fprintf(fpbackup, "%s\n", buf);
		    fprintf(fpbackup, "%s\n", buf);
		    isname = TRUE;
		    i++;
		    j++;
		    continue;
		}
		if(isname == TRUE)
		{
		    abTable->setText(i, 0, buf);
		    fprintf(fpbackup, "%s\n", buf);
		    isname = FALSE;
		    i++;
		}
		else
		{
		    abTable->setText(j, 1, buf);
		    fprintf(fpbackup, "%s\n", buf);
		    isname = TRUE;
		    j++;
		}
	    }
	}
	else
	{
	   QMessageBox::critical(this, "Error", "Server isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	    return;
	}
	fclose(fpbackup);
	
	// Disconnecting from daemon
	global->socket->~QSocketDevice();
	delete(global);
    }
    else
    {
	QMessageBox::critical(this, "Error", "Server isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
}


void abForm::useNumberButtonSlot()
{
    int current;
    QString selnumber;
    smsForm *smsform = new smsForm(this);
    
    current = abTable->currentRow();
    selnumber = abTable->text(current, 1);
    smsform->toLineEdit->setText(selnumber);
    smsform->show();
}


void abForm::readAbSlot()
{
    FILE *fpbackup;
    char backupfn[1024];
    bool isname = TRUE;
    int wclines;
    unsigned int i,j;
    unsigned int n;
    char buf[1024];
   
    // Where the data file is?
    sprintf(backupfn, "%s/.qgnokii/addressbook", getenv("HOME"));
    
    // Open backup file for read
    if((fpbackup = fopen(backupfn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Internal error. Can't open backup data file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
    // Calculating the length of data file with names
    wclines = 0;
    while((fgets(buf, sizeof(buf), fpbackup)) != NULL)
    {
	for(n = 0; n < strlen(buf); n++)
	    if(buf[n] == '\n')
		wclines++;
	n++;
    }
    wclines = wclines / 2;
    // We must rewind the file
    rewind(fpbackup);
    
    abTable->setNumRows(wclines);
    
    // Reading data from file and filling the sheet
    i = 0;
    j = 0;
    while(fgets(buf, sizeof(buf), fpbackup) != NULL)
     {
	if(strcmp(buf, "Empty name") == 0)
	{
	    abTable->setText(i, 0, buf);
	    abTable->setText(j, 1, buf);
	    isname = TRUE;
	    i++;
	    j++;
	    continue;
	}
	if(isname == TRUE)
	{
	    abTable->setText(i, 0, buf);
	    fprintf(fpbackup, "%s\n", buf);
	    isname = FALSE;
	    i++;
	}
	else
	{
	    abTable->setText(j, 1, buf);
	    fprintf(fpbackup, "%s\n", buf);
	    isname = TRUE;
	    j++;
	}
    }
    
}


void abForm::addEntrySlot()
{
    addAbEntryForm *addabentryform = new addAbEntryForm(this);
    
    addabentryform->show();
}


void abForm::delEntrySlot()
{
    int current;
    char currentstr[8];
    bool telmem;
    char code[3];
    qgnokii_global *global = new qgnokii_global;
    
    telmem = FALSE;
    
    // Checking if readFromTelMemCheckBox is set
    if(readFromTelMemCheckBox->isChecked())
	telmem = TRUE;
    
    // Getting position of current entry
    current = abTable->currentRow();
    current++;
    sprintf(currentstr, "%d", current);
    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Can't connect to QGnokiid", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
     // Sending request to the qgnokii daemon
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(DELPB_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, DELPB_CODE) == 0)
	{
	    if(telmem == TRUE)
		global->socket->writeBlock("ME", 3);
	    else
		global->socket->writeBlock("SM", 3);
	   global->socket->writeBlock(currentstr, strlen(currentstr)+1);
	   global->socket->readBlock(code, CODE_LEN);
	   QMessageBox::information(this, "Info", "Selected entry deleted");
	}
	else
	    QMessageBox::critical(this, "Error", "QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    }
    else
	QMessageBox::critical(this, "Error", "QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    global->socket->~QSocketDevice();
    delete(global);
}    


void abForm::editEntrySlot()
{
    int current;
    char currentstr[8];
    char cmd[2048];
    QString name;
    QString num;
    bool telmem = FALSE;
    editAbEntryForm *editabentryform = new editAbEntryForm(this);
    
    // Checking if readFromTelMemCheckBox is set
    if(readFromTelMemCheckBox->isChecked())
	telmem = TRUE;
    
    // Getting position of current entry
    current = abTable->currentRow();
    sprintf(currentstr, "%d", current);
    
    // Getting values of fields
    name = abTable->text(current, 0);
    num = abTable->text(current, 1);
    
    // Assembling command
    strcpy(cmd, "gnokii --deletephonebook ");
    if(telmem == TRUE)
	strcat(cmd, "ME ");
    else
	strcat(cmd, "SM ");
    strcat(cmd, currentstr);
    
    // Executing it
    system(cmd);
    editabentryform->nameLineEdit->setText(name);
    editabentryform->numberLineEdit->setText(num);
    editabentryform->phoneMemCheckBox->setChecked(telmem);
    editabentryform->position = current;
    editabentryform->show();
}
