/*
 * $Id: editabentryform.ui.h,v 1.2 2006/08/28 14:34:36 pjedryczek Exp $
 */ 

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <qmessagebox.h>
#include "global.h"

void editAbEntryForm::saveSlot()
{
    QString name;
    QString number;
    int group;
    char positionStr[8];
    char groupStr[2];
    char memtype[3];
    char code[3];
    char csv[2048];
    qgnokii_global *global = new qgnokii_global;
    
    position++;
    sprintf(positionStr, "%d", position);
    
    
    // Getting data from user
    name = nameLineEdit->text();
    number = numberLineEdit->text();
    group = groupComboBox->currentItem();
    sprintf(groupStr, "%d", group);
    if(phoneMemCheckBox->isChecked())
	strcpy(memtype, "ME");
    else
	strcpy(memtype, "SM");
   
    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Can't connect to QGnokiid", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    // Sending request to the qgnokii daemon
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(WRITEPB_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, WRITEPB_CODE) == 0)
	{
	    // Building CSV formatted string
	    sprintf(csv, "%s;%s;%s;%s;%s", name.ascii(), number.ascii(), memtype, positionStr, groupStr);
    
	    global->socket->writeBlock("1", 2);
	    global->socket->writeBlock(memtype, strlen(memtype)+1);	
	    global->socket->writeBlock(csv, strlen(csv)+1);
	    usleep(100);
	    global->socket->readBlock(code, CODE_LEN);
	    if(strcmp(code, END_CODE) == 0)
		QMessageBox::about(this, "Confirmation", "You should refetch your address book now");
	    else
		QMessageBox::critical(this, "Error", "Can't add entry", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	}
	else
	    QMessageBox::critical(this, "Error", "QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    }
    else
	QMessageBox::critical(this, "Error", "QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    global->socket->~QSocketDevice();
    delete(global);
}
