/*
 * $Id: global.h,v 1.4 2006/09/09 18:51:54 pjedryczek Exp $
 */
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <stdlib.h>
#include <qmessagebox.h>
#include <qsocketdevice.h>
#include <qhostaddress.h>
#include <errno.h>

/*******************************************************************************
* Meaning of codes:
* 00 - begin code
* 98 - error code
* 99 - end code
* 01 - identify request
* 02 - send SMS request
* 03 - get contents of the phonebook request
* 04 - get ToDo list request
* 05 - purge ToDo list request
* 06 - delete phonebook entry
* 07 - write phonebook entry
* all other - request code
*******************************************************************************/

#define BEGIN_CODE "00"
#define END_CODE "99"
#define ERR_CODE "98"
#define IDENTIFY_CODE "01"
#define SENDSMS_CODE "02"
#define GETPB_CODE "03"
#define GETTODO_CODE "04"
#define PURGETODO_CODE "05"
#define DELPB_CODE "06"
#define WRITEPB_CODE "07"
#define CODE_LEN 3
#define MAXLINE 1024
#define OK_MSG "OK"


class qgnokii_global
{
public:
	QHostAddress address;
	QSocketDevice *socket;

	int connectQSocketDevice()
	{
		FILE *settingsfp;
		char ip_str[16];
		char *homedir = new char[1024];
		char *filename = new char[1024];
    
		socket = new QSocketDevice(QSocketDevice::Stream);
		/* Read config file */
		homedir = getenv("HOME");
		strcpy(filename, homedir);
		strcat(filename, "/.qgnokii/config");
		if((settingsfp = fopen(filename, "r")) == NULL)
			return errno;
		fgets(ip_str, sizeof(ip_str), settingsfp);
		address.setAddress(ip_str);
		if((socket->connect(address, 9000)) == FALSE)
			return errno;
		return 0;
	}
};
