/*
 * $Id: identifyform.ui.h,v 1.3 2006/11/12 14:38:54 pjedryczek Exp $
 */

/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include "global.h"


void identifyForm::init()
{
    char code[3];
    char data[161];
    char buf[64];
    qgnokii_global *global = new qgnokii_global;
    int i = 0;
    int j = 0;
    int field = 1;

    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Can't connect to QGnokiid", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(IDENTIFY_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, IDENTIFY_CODE) == 0)
	{
	    global->socket->readBlock(data, sizeof(data));
	    /* Parse incoming data (in format: imei;revision;model;manufacturer;*/
	    while(data[i] != '\0')
	    {
		if(data[i] != ';')
		{
		    buf[j] = data[i];
		    j++;
		}
		else
		{
		    buf[j] = '\0';
		    if(field == 1)
			imeiLineEdit->setText(buf);
		    else if(field == 2)
			revisionLineEdit->setText(buf);
		    else if(field == 3)
			modelLineEdit->setText(buf);
		    else if(field == 4)
			manufacturerLineEdit->setText(buf);
		    j = 0;
		    field++;
		}
		i++;
	    }
	    global->socket->readBlock(code, CODE_LEN);
	    if(strcmp(code, END_CODE) != 0)
	    {
		QMessageBox::critical(this, "Error", "Transmission error", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
		return;
	    }
	}
	else
	{
	    QMessageBox::critical(this, "Error", "Server isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	    return;
	}
    }
}
