/*
 * $Id: main.cc,v 1.3 2006/04/28 15:40:44 pjedryczek Exp $
 */
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include <qapplication.h>
#include "mainform.h"
#include <qmessagebox.h>
#include <qtextedit.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
int main(int argc, char *argv[])
{
	QApplication app(argc, argv);
	mainForm *mainform = new mainForm;

	char *homedir = new char[1024];
	char *homedir2 = new char[1024];
    	char *qgnokiiprefix = new char[1024];
    	char *qgnokiiprefix2 = new char[1024];
    	char *buff = new char[1024];
    	FILE *helpfilefp;
    	FILE *licensefilefp;
    	FILE *orighelpfilefp;
    	FILE *origlicensefilefp;
   
	/* Creating user's config directory if it doesn't exists */ 
    	homedir = getenv("HOME");
	/* We must copy homedir to homedir2, because we will
	 modify homedir2 (and we want to save homedir) */
	strcpy(homedir2, homedir);
	/* Checking if user's config directory exists. If no, creating it */
    	if((mkdir(strcat(homedir2, "/.qgnokii"), S_IRWXU)) == 0)
    	{
		printf("Personal data directory not found. Creating it\n");
		/* In QGNOKII_PREFIX should be installation prefix */
		qgnokiiprefix = getenv("QGNOKII_PREFIX");
		strcpy(qgnokiiprefix2, qgnokiiprefix);
		/* Copying the LICENSE file */
		if((origlicensefilefp = fopen(strcat(qgnokiiprefix2, "/share/qgnokii/LICENSE"), "r")) != NULL)
		{
			strcpy(homedir2, homedir);
			if((licensefilefp = fopen(strcat(homedir2, "/.qgnokii/LICENSE"), "w")) != NULL)
		 	{ 
				while((fgets(buff, sizeof(buff), origlicensefilefp)) != NULL)
			    		fputs(buff, licensefilefp);
				fclose(licensefilefp);
	    		}
	   		else
				printf("Can't write license file.\n");
	    		fclose(origlicensefilefp);
		}
		else
			printf("Can't read license file\n");
		/* We must copy qgnokiiprefix to qgnokiiprefix2, because we will
	   	  modify qgnokiiprefix2 (and we want to save qgnokiiprefix) */
		strcpy(qgnokiiprefix2, qgnokiiprefix);
		/* Copying the help file */
		if((orighelpfilefp = fopen(strcat(qgnokiiprefix2, "/share/qgnokii/helpfile"), "r")) != NULL)
		{
			strcpy(homedir2, homedir);
			if((helpfilefp = fopen(strcat(homedir2, "/.qgnokii/helpfile"), "w")) != NULL)
		    	{
				while((fgets(buff, sizeof(buff), orighelpfilefp)) != NULL)
			    		fputs(buff, helpfilefp);
				fclose(helpfilefp);
			}
			else
				printf("Can't write help file\n");
			fclose(orighelpfilefp);
		}
		else
			printf("Can't read help file\n");
	}
	/* Showing main form */
	app.setMainWidget(mainform);
	mainform->show();
	return app.exec();
}
