/*
 * $Id: mainform.ui.h,v 1.13 2006/11/12 15:16:50 pjedryczek Exp $
 */


/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include "smsform.h"
#include "helpform.h"
#include "abform.h"
#include "gnuform.h"
#include "modemform.h"
#include "todoform.h"
#include "settingsform.h"
#include "global.h"
#include "identifyform.h"
#include "modemsettingsform.h"
#include <qmessagebox.h>
#include <qtextedit.h>
#include <qsocketdevice.h>
#include <qhostaddress.h> 
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>


void mainForm::smsOpenForm()
{
    smsForm *smsform = new smsForm(this);
    smsform->show();
}


void mainForm::showAboutDialog()
{
    QMessageBox::about(this, "About QGnokii", "QGnokii 0.4.2 by Piotr Jedryczek <pjedryczek@gmail.com>\nDistributed under the terms of GNU GPL v2 license\nQGnokii comes with ABSOLUTELY NO WARRANTY;\nThis is free software, and you are welcome to redistribute it under certain conditions.\nSee LICENSE file for details");
}


void mainForm::showHelpContent()
{
    FILE *fp;
    char buf[1024];
    char helpfn[1024];
    char *homedir = new char;
    
    // Get $HOME
    homedir = getenv("HOME");
    
    // Where the help file is?
    strcpy(helpfn, homedir);
    strcat(helpfn, "/.qgnokii/helpfile");
    
    helpForm *helpform = new helpForm(this);
    helpform->show();
    if((fp = fopen(helpfn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Error while opening help file \nHelp won't work!", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    while((fgets(buf, sizeof(buf), fp)) != NULL)
    {
	helpform->helpTextEdit->append(buf);
    }
}


void mainForm::abOpenForm()
{
    abForm *abform = new abForm(this);
    abform->show();
}


void mainForm::showGNUDialog()
{
    FILE *fp;
    char buf[1024];
    char licensefn[1024];
    char *homedir = new char;
    
    // Get $HOME
    homedir = getenv("HOME");
    
    // Where the license file is?
    strcpy(licensefn, homedir);
    strcat(licensefn, "/.qgnokii/LICENSE");
    
    gnuForm *gnuform = new gnuForm(this);
    gnuform->show();
    if((fp = fopen(licensefn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Error while opening license file! Why?", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    while((fgets(buf, sizeof(buf), fp)) != NULL)
    {
	gnuform->gnuTextEdit->append(buf);
    }
}


void mainForm::modemOpenForm()
{
    modemForm *modemform = new modemForm(this);
    modemform->show();
}


void mainForm::todoOpenForm()
{
    todoForm *todoform = new todoForm(this);
    todoform->show();
}


void mainForm::settingsOpenForm()
{
    settingsForm *settingsform = new settingsForm(this);
    settingsform->show();
}

void mainForm::identifyOpenForm()
{
    identifyForm *identifyform = new identifyForm(this);
    identifyform->show();
}


void mainForm::modemSettingsOpenForm()
{
    modemSettingsForm *modemsettingsform = new modemSettingsForm(this);
    modemsettingsform->show();
}
