/*
 * $Id: modemform.ui.h,v 1.4 2006/04/28 15:40:44 pjedryczek Exp $
*/
/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/

#include "modemsettingsform.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <qmessagebox.h>
#include <pthread.h>
#include <signal.h>

pthread_t chtid;
char pppcmd[1024];

void modemForm::modemSettingsOpenForm()
{
    modemSettingsForm *modemsettingsform = new modemSettingsForm(this);
    modemsettingsform->show();
}


void modemForm::connectNetSlot()
{
    char dialupNumber[1024];
    char username[1024];
    char password[1024];
    char initString[1024];
    char init2String[1024];
    char dialingCmd[1024];
    char tty[1024];
    char baudRate[1024];
    char currcmd[2048];
    char *homedir = new char[1024];
    char filename[1024];
    FILE *settingsfp;
    FILE *chatfp;
    bool isInit2 = TRUE;
    int len;
    
    void *exec_pppd(void *);

    // Getting path to home directory
    homedir = getenv("HOME");
    
    strcpy(filename, homedir);
    strcat(filename, "/.qgnokii/modem.conf");
    
    // Reading data from modem configuration file
    if((settingsfp = fopen(filename, "r")) == NULL)
    {
        QMessageBox::critical(this, "Error", "Error. Can't open modem configuration file for reading!", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
        return;
    }
    fgets(dialupNumber, sizeof(dialupNumber), settingsfp);
    fgets(username, sizeof(username), settingsfp);
    fgets(password, sizeof(password), settingsfp);
    fgets(initString, sizeof(initString), settingsfp);
    fgets(init2String, sizeof(init2String), settingsfp);
    fgets(dialingCmd, sizeof(dialingCmd), settingsfp);
    fgets(tty, sizeof(tty), settingsfp);
    fgets(baudRate, sizeof(baudRate), settingsfp);
    fclose(settingsfp);
    
    // We must delete newlines from some variables
    len = strlen(dialingCmd);
    dialingCmd[len-1] = '\0';
    len = strlen(dialupNumber);
    dialupNumber[len-1] = '\0';
    len = strlen(tty);
    tty[len-1] = '\0';
    len = strlen(baudRate);
    baudRate[len-1]='\0';
    len = strlen(username);
    username[len-1] = '\0';
    len = strlen(password);
    password[len-1] = '\0';
    len = strlen(initString);
    initString[len-1] = '\0';
    len = strlen(init2String);
    init2String[len-1] = '\0';
    
    // Checking if init2String is necessary
    if((strcmp(init2String, "-\n")) == 0)
        isInit2 = FALSE;
    
    // Generating chatscript
    if((chatfp = fopen("/tmp/qgnokii.chat", "w")) == NULL)
    {
        QMessageBox::critical(this, "Error", "Error. Can't generate chatscript. Can't open chatscript file for writing.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
        return;
    }
    strcpy(currcmd, "'' ");
    strcat(currcmd, "\"");
    strcat(currcmd, initString);
    strcat(currcmd, "\"");
    fprintf(chatfp, "%s\n", currcmd);
    if(isInit2 == TRUE)
    {
        strcpy(currcmd, "OK ");
        strcat(currcmd, "\"");
        strcat(currcmd, init2String);
        strcat(currcmd, "\"");
        fprintf(chatfp, "%s\n", currcmd);
    }
    strcpy(currcmd, "OK \"");
    strcat(currcmd, dialingCmd);
    strcat(currcmd, dialupNumber);
    strcat(currcmd, "\"");
    fprintf(chatfp, "%s\n", currcmd);
    strcpy(currcmd, "CONNECT ''");
    fprintf(chatfp, "%s\n", currcmd);
    fclose(chatfp);
    
    // Assembling pppd command
    strcpy(pppcmd, "pppd ");
    strcat(pppcmd, tty);
    strcat(pppcmd, " ");
    strcat(pppcmd, baudRate);
    strcat(pppcmd, " connect \"chat -V -f /tmp/qgnokii.chat\" crtscts modem -detach noccp defaultroute usepeerdns user ");
    strcat(pppcmd, username);
    strcat(pppcmd, " password ");
    strcat(pppcmd, password);
    strcat(pppcmd, " ipcp-accept-remote ipcp-accept-local noipdefault noauth");
    
    if((pthread_create(&chtid, NULL, exec_pppd, NULL)) != 0)
    {
        QMessageBox::critical(this, "Error", "Error. Can't create thread! PPPD won't run.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
        return;
    }
}


void modemForm::disconnectNetSlot()
{   
    // Disconnecting PPP connection - signal 10 is used to terminate thread calling pppd
    pthread_kill(chtid, 10);
}

void exec_pppd(void *)
{
    void get_sig10(int);
 
    // Catching signal 10
    signal(10, get_sig10);
    
    // Executing pppd
    system(pppcmd);
    pthread_exit(0);
}

void get_sig10(int)
{
    // Terminating thread
    printf("Disconnecting\n");
    pthread_exit(0);
}
