/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qmessagebox.h>

void modemSettingsForm::init()
{
    char dialupNumber[1024];
    char username[1024];
    char password[1024];
    char initString[1024];
    char init2String[1024];
    char dialingCmd[1024];
    char tty[1024];
    char baudRate[1024];
    char *homedir = new char[1024];
    char *filename = new char[1024];
    FILE *settingsfp;
    int len;
    
    // Filling line edits with data from configuration file
    homedir = getenv("HOME");
    strcpy(filename, homedir);
    strcat(filename, "/.qgnokii/modem.conf");
    
    if((settingsfp = fopen(filename, "r")) == NULL)
    {
	QMessageBox::warning(this, "Warning", "Modem configuration file doesn't exist. Please fill the form.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
 
    fgets(dialupNumber, sizeof(dialupNumber), settingsfp);
    fgets(username, sizeof(username), settingsfp);
    fgets(password, sizeof(password), settingsfp);
    fgets(initString, sizeof(initString), settingsfp);
    fgets(init2String, sizeof(init2String), settingsfp);
    fgets(dialingCmd, sizeof(dialingCmd), settingsfp);
    fgets(tty, sizeof(tty), settingsfp);
    fgets(baudRate, sizeof(baudRate), settingsfp);
    fclose(settingsfp);
   
    // We must delete newlines from some variables
    len = strlen(dialupNumber);
    dialupNumber[len-1] = '\0';
    len = strlen(username);
    username[len-1] = '\0';
    len = strlen(password);
    password[len-1] = '\0';
    len = strlen(initString);
    initString[len-1] = '\0';
    len = strlen(init2String);
    init2String[len-1] = '\0';    
    len = strlen(dialingCmd);
    dialingCmd[len-1] = '\0';
    len = strlen(tty);
    tty[len-1] = '\0';
    len = strlen(baudRate);
    baudRate[len-1] = '\0';
    
    dialupNumberLineEdit->setText(dialupNumber);
    usernameLineEdit->setText(username);
    passwordLineEdit->setText(password);
    initLineEdit->setText(initString);
    init2LineEdit->setText(init2String);
    dialCommandLineEdit->setText(dialingCmd);
    ttyLineEdit->setText(tty);
    baudRateLineEdit->setText(baudRate);    
}

void modemSettingsForm::saveSettingsSlot()
{
    QString dialupNumber;
    QString username;
    QString password;
    QString initString;
    QString init2String;
    QString dialingCmd;
    QString tty;
    QString baudRate;
    char *homedir = new char[1024];
    char *filename = new char[1024];
    FILE *settingsfp;
    
    // Getting data from user
    dialupNumber = dialupNumberLineEdit->text();
    username = usernameLineEdit->text();
    password = passwordLineEdit->text();
    initString = initLineEdit->text();
    init2String = init2LineEdit->text();
    dialingCmd = dialCommandLineEdit->text();
    tty = ttyLineEdit->text();
    baudRate = baudRateLineEdit->text();
    
    homedir = getenv("HOME");
    strcpy(filename, homedir);
    strcat(filename, "/.qgnokii/modem.conf");
    
    // Saving data to file
    if((settingsfp = fopen(filename, "w")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Error. Can't open modem configuration file for writing!", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    fprintf(settingsfp, "%s\n", (const char *)dialupNumber);
    fprintf(settingsfp, "%s\n", (const char *)username);
    fprintf(settingsfp, "%s\n", (const char *)password);
    fprintf(settingsfp, "%s\n", (const char *)initString);
    fprintf(settingsfp, "%s\n", (const char *)init2String);
    fprintf(settingsfp, "%s\n", (const char *)dialingCmd);
    fprintf(settingsfp, "%s\n", (const char *)tty); 
    fprintf(settingsfp, "%s\n", (const char *)baudRate);   
    fclose(settingsfp);
    close();
}
