/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
/****************************************************************************
   QGnokii - an alternative frontend for Gnokii
    Copyright (C) 2006  Piotr Jedryczek

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
**************************************************************************/
#include <string.h>
#include <qmessagebox.h>
#include <qregexp.h>
#include <stdio.h>
#include <unistd.h>
#include "global.h"

void todoForm::fetchTodoSlot()
{   
    char buf[1024];
    char code[3];
    bool isname;
    FILE *fp;
    int n = 0;
    int wcnames = 0;
    char backupfn[1024];
    qgnokii_global *global = new qgnokii_global;
    
    
    // Where the data file is?
    sprintf(backupfn, "%s/.qgnokii/todolist", getenv("HOME"));
    
    // Connecting to server
    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Error. Can't connect to QGnokiid",QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	 return;
     }
    
    // Sending request to server
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(GETTODO_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, GETTODO_CODE) == 0)
	{
	    if((fp = fopen(backupfn, "w")) == NULL)
	    {
		QMessageBox::critical(this, "Error", "Internal error. Can't open names data file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
		return;
	    }
	    while(strcmp(buf, "99") != 0)
	    {
		global->socket->readBlock(buf, sizeof(buf));
		fprintf(fp, "%s\n", buf);
	    }
	    fclose(fp);
	    if((fp = fopen(backupfn, "r")) == NULL)
	    {
		QMessageBox::critical(this, "Error", "Internal error. Can't open names data file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
		return;
	    }
	    
	    // Counting number of lines in file with todos
	    while((fgets(buf, sizeof(buf), fp)) != NULL)
	    {
		for(n = 0; n < strlen(buf); n++)
		    if(buf[n] == '\n')
			wcnames++;
		n++;
	    }
	    // We must rewind the file	    
	    rewind(fp);
	    
	    //Setting length of the sheet
	    todoTable->setNumRows((wcnames-1)/2);
	    isname = TRUE;
	    n = 0;
	    while((fgets(buf, sizeof(buf), fp) != NULL) && (strcmp(buf, "99") != 0))
	    {
		if(isname == TRUE)
		{
		    todoTable->setText(n, 0, buf);
		    isname = FALSE;
		}
		else
		{
		    todoTable->setText(n, 1, buf);
		    isname = TRUE;
		    n++;
		}
		if(strcmp(buf, "99") == 0)
		    break;
	    }
	}
    }
    
	    
}


void todoForm::readTodoSlot()
{
    /*
    FILE *fppriorities;
    FILE *fpnames;
    unsigned int n;
    int wcnames;
    char priority[2048];
    char name[2048];
    char namesfn[1024];
    char prioritiesfn[1024];
    char *homedir = new char;
    char buf[1024];
    
    // Get $HOME
    homedir = getenv("HOME");
    
    // Where data files are?
    strcpy(namesfn, homedir);
    strcat(namesfn, "/.qgnokii/todonames.td");
    strcpy(prioritiesfn, homedir);
    strcat(prioritiesfn, "/.qgnokii/todopriorities.td");
  
    // Opening data files
    if((fpnames = fopen(namesfn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Can't open ToDo list's data file", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    if((fppriorities = fopen(prioritiesfn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Can't open ToDo list's data file", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
    // Calculating the length of data file with names
    wcnames = 0;
    while((fgets(buf, sizeof(buf), fpnames)) != NULL)
    {
	for(n = 0; n < strlen(buf); n++)
	    if(buf[n] == '\n')
		wcnames++;
	n++;
    }
    // We must rewind the file
    rewind(fpnames);
    
    //Setting length of the sheet
    todoTable->setNumRows(wcnames);
    
    n = 0;
    // Getting data and filling the sheet
     while((fgets(name, sizeof(name), fpnames)) != NULL)
    {
	todoTable->setText(n, 0, name);
	n++;
    }
    n = 0;
    while((fgets(priority, sizeof(priority), fppriorities)) != NULL)
    {
	todoTable->setText(n, 1, priority);
	n++;
    }
    */
    //QMessageBox::information(this, "Deprecated function", "This function is deprecated and will be removed soon\nSee DEPRECATED file for informations about enabling it\nPlease note that it is probably broken.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    FILE *fpbackup;
    char backupfn[1024];
    bool isname = TRUE;
    int wclines;
    unsigned int i,j;
    unsigned int n;
    char buf[1024];
   
    // Where the data file is?
    sprintf(backupfn, "%s/.qgnokii/todolist", getenv("HOME"));
    
    // Open backup file for read
    if((fpbackup = fopen(backupfn, "r")) == NULL)
    {
	QMessageBox::critical(this, "Error", "Internal error. Can't open backup data file.", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	return;
    }
    
    // Calculating the length of data file with names
    wclines = 0;
    while((fgets(buf, sizeof(buf), fpbackup)) != NULL)
    {
	for(n = 0; n < strlen(buf); n++)
	    if(buf[n] == '\n')
		wclines++;
	n++;
    }
    
    // We must rewind the file
    rewind(fpbackup);
    
    wclines = wclines/2;
    todoTable->setNumRows(wclines);
    
    // Reading data from file and filling the sheet
    i = 0;
    j = 0;
    while(fgets(buf, sizeof(buf), fpbackup) != NULL)
     {
	if(strcmp(buf, "99") == 0)
	    break;
	if(isname == TRUE)
	{
	    todoTable->setText(i, 0, buf);
	    fprintf(fpbackup, "%s\n", buf);
	    isname = FALSE;
	    i++;
	}
	else
	{
	    todoTable->setText(j, 1, buf);
	    fprintf(fpbackup, "%s\n", buf);
	    isname = TRUE;
	    j++;
	}
    }
}


void todoForm::purgeAllSlot()
{
    char code[3];
    qgnokii_global *global = new qgnokii_global;
   
    // Purging ToDo List
    if(global->connectQSocketDevice() != 0)
    {
	QMessageBox::critical(this, "Error", "Error. Can't connect to QGnokiid",QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	 return;
     }
    global->socket->writeBlock(BEGIN_CODE, CODE_LEN);
    global->socket->writeBlock(PURGETODO_CODE, CODE_LEN);
    global->socket->readBlock(code, CODE_LEN);
    if(strcmp(code, BEGIN_CODE) == 0)
    {
	global->socket->readBlock(code, CODE_LEN);
	if(strcmp(code, PURGETODO_CODE) == 0)
	{
	    global->socket->readBlock(code, CODE_LEN);
	    if(strcmp(code, END_CODE) == 0)
		QMessageBox::information(this, "Info", "ToDo list purged");
	    else
		QMessageBox::critical(this, "Error", "Error. Can't purge ToDo list", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
	}
	else
	    QMessageBox::critical(this, "Error", "Error. QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
    }
    else
	QMessageBox::critical(this, "Error", "Error. QGnokiid isn't responding properly", QMessageBox::Ok, QMessageBox::NoButton, QMessageBox::NoButton);
}
